#include <QApplication>

#include "PreprocessorThread.h"
#include "Camera.h"
#include "KdTree.h"
#include "SceneGraph.h"
#include "Preprocessor.h"



PreprocessorThread::PreprocessorThread(Preprocessor *p,
									   QObject *parent):QThread(parent)
{
  mPreprocessor = p;
}

void
PreprocessorThread::Main()
{
     
  if (1) {
    mPreprocessor->ComputeVisibility();
    mPreprocessor->ExportPreprocessedData("scene.vis");
  }
  
  Camera camera;
  if (0) {
    camera.LookAtBox(mPreprocessor->mKdTree->GetBox());
	//	camera.LookInBox(mPreprocessor->mKdTree->GetBox());
	//	camera.SetPosition(camera.mPosition + Vector3(0,300,0));
    camera.SnapImage("camera.jpg", mPreprocessor->mKdTree, mPreprocessor->mSceneGraph);
  }
  if (0) {
    camera.LookInBox(mPreprocessor->mKdTree->GetBox());
    camera.SetPosition(camera.mPosition + Vector3(-250,0,-550));
    camera.SnapImage("camera2.jpg", mPreprocessor->mKdTree, mPreprocessor->mSceneGraph);
  }

  if (0) {
    camera.SetPosition( mPreprocessor->mKdTree->GetBox().Center() - Vector3(0,-100,0) );
	camera.SetDirection(Vector3(1, 0, 0));
	camera.SnapImage("camera3.jpg", mPreprocessor->mKdTree, mPreprocessor->mSceneGraph);
  }

  QApplication::quit();
  
}
